/*
###########################################################################
# trustyRC, fully modular IRC robot 
# Copyright (C) 2006-2008 Nicoleau Fabien
#
# trustyRC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 0.1.2-1307 USA
###########################################################################
*/

/** @file antiflood.cpp
 * @brief AntiFlood implementation file
 */

#include "antiflood.h"

/**
 * Constructor
 */ 
AntiFlood::AntiFlood(BotKernel*b)
{
	this->author = "eponyme";
	this->description = "antiflood plugin";
	this->version = "0.1.2";
	this->name = "antiflood";
	this->bindFunction("",IN_BEFORE_TREATMENT,"testMsgTimestamp",0,10);
}

extern "C"
{
	Plugin *contruct_antiflood(BotKernel*b)
	{
		return new AntiFlood(b);
	}
	void destroy_antiflood(Plugin*p)
	{
		delete p;
	}
	bool testMsgTimestamp (Message*m,Plugin*p,BotKernel*b)
	{
      pPlugin * ppAdm = b->getPlugin("admin");
      Admin*adm = NULL;
      if (ppAdm!=NULL) {
         adm = (Admin*)ppAdm->object ;
         string maxtime = b->getCONFF()->getValue(p->getName()+".maxtime");
         if ( (m->getPart(1) == "PRIVMSG") && (maxtime != "") && (maxtime != "0") && (m->getElapsedTime()>Tools::strToInt(maxtime)) ) {
            if ( ( b->getCONFF()->getValue(p->getName()+".allowsa") == "1") &&  adm->isSuperAdmin(m->getSender()) ) {
               return true;            
            }
            else {
               return false;
            }
         }
      }
		return true;
	}
}
